﻿Public Class GadgetSetForm

    Private Sub GadgetSetForm_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\Gadget Creator\tmp\"
        Try
            If System.IO.File.Exists(path + "gadget.xml") = True Then
                Dim xmlreader As System.Xml.XmlDocument
                xmlreader = New System.Xml.XmlDocument()
                xmlreader.Load(path + "gadget.xml")
                Dim name As String = xmlreader.SelectSingleNode("//name").InnerText
                TextBox1.Text = name
                Dim version As String = xmlreader.SelectSingleNode("//version").InnerText
                TextBox2.Text = version
                Dim author As String = xmlreader.SelectSingleNode("//copyright").InnerText
                TextBox3.Text = author
                Dim description As String = xmlreader.SelectSingleNode("//description").InnerText
                TextBox4.Text = description
                If System.IO.File.Exists(path + "icon.png") = True Then
                    PictureBox1.Load(path + "icon.png")
                End If
                If System.IO.File.Exists(path + "dock.png") = True Then
                    PictureBox2.Load(path + "dock.png")
                End If
            Else
                Exit Sub
            End If
        Catch ex As Exception
            MsgBox(ex.Message, 16, "Error")
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\Gadget Creator\tmp\gadget.xml"
            Dim modify As New System.Xml.XmlDocument()
            modify.Load(path)
            Dim name As Xml.XmlNode = modify.SelectSingleNode("//name")
            name.InnerText = TextBox1.Text
            Dim version As Xml.XmlNode = modify.SelectSingleNode("//version")
            version.InnerText = TextBox2.Text
            Dim copyright As Xml.XmlNode = modify.SelectSingleNode("//copyright")
            copyright.InnerText = TextBox3.Text
            Dim description As Xml.XmlNode = modify.SelectSingleNode("//description")
            description.InnerText = TextBox4.Text
            modify.Save(path)
            Me.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\Gadget Creator\tmp\"
        Dim ofd As New OpenFileDialog
        ofd.Filter = "PNG files|*.png"
        ofd.Title = "Choose gadget logo"
        ofd.Multiselect = False
        ofd.AddExtension = False
        If ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                System.IO.File.Copy(ofd.FileName, path + "icon.png")
                PictureBox1.Load(path + "icon.png")
            Catch ex As Exception
                MsgBox("File was not opened! " + ex.Message)
            End Try
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\Gadget Creator\tmp\"
        Dim ofd As New OpenFileDialog
        ofd.Filter = "PNG files|*.png"
        ofd.Title = "Choose drag and drop image"
        ofd.Multiselect = False
        ofd.AddExtension = False
        If ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                System.IO.File.Copy(ofd.FileName, path + "dock.png")
                PictureBox2.Load(path + "dock.png")
            Catch ex As Exception
                MsgBox("File was not opened! " + ex.Message)
            End Try
        End If
    End Sub
End Class